%define snapshot 20070403

%define ltspadmin_user ltspadmin
%define Codename Sisyphus

%define Name LTSP5
%define bname ltsp
Name: ltsp5
Version: 5.0
Release: alt0.12
Summary: %Name
License: GPL
Group: Networking/Remote access
URL: http://%bname.org/
%ifdef snapshot
# bzr get http://bazaar.launchpad.net/~ogra/ltsp/ltsp-mainline ltsp-%snapshot; rm -rf ltsp-%snapshot/.bzr*
Source0: %bname-%snapshot.tar.bz2
%else
Source0: %bname-%version.tar.bz2
%endif
Source1: %bname-build-client.conf
Source2: %bname-client-setup.default
Source3: %bname-client.init
Source4: %bname-client-setup.init
Source5: lts.conf.default
Source6: %name-%Codename-specific.tar
Source7: gen-%bname-image.sh
Source8: %bname-client-bind-mounts.init
Source9: %bname-client-eth-modules.list
Source10: %bname-client-mkinitrd.sh
Source11: %bname-update-kernels.conf
Source12: %bname-client-sound.sh
Patch0: %name-start_telnet.patch
Patch1: %name-startx.patch
Patch2: %name-alt.patch

BuildRequires: libpopt-devel flex

%description
%Name.


%package server
Summary: %Name server
Group: Networking/Remote access
AutoReq: yes, noshell
Requires: gettext-tools

%description server
%Name server.


%package client
Summary: %Name client
Group: Networking/Remote access
Requires: mkinitrd-initramfs
Provides: %_sysconfdir/%{bname}_chroot
AutoReq: yes, noshell
Conflicts: grub, lilo

%description client
%Name client.


%package -n ldm
Summary: Display manager for LTSP
Group: System/X11

%description -n ldm
A display manager for LTSP.
ldm starts an X server and presents the user with a login screen,
similar to the xdm(1) login prompt.
Instead of using the XDMCP protocol, ldm(1) uses ssh(1) and
X Forwarding to connect to remote servers.
It was designed for the LTSP project, but could be used in a non-ltsp
environment as well.


%prep
%ifdef snapshot
%setup -n %bname-%snapshot
%else
%setup -n %bname-%version
%endif
%patch0 -p1
%patch1 -p1
%patch2 -p1
tar -C server/plugins/ltsp-build-client -xf %SOURCE6


%build
%define _optlevel s
%define Vendor %(lsb_release -s -c)
subst "s/@VENDOR@/%Codename/g" server/%bname-build-client client/update-kernels
%make_build -C client/getltscfg CFLAGS="%optflags"
%make_build -C po


%install
%make_install -C po DESTDIR=%buildroot install
bzip2 --best --keep --force debian/changelog
install -d -m 0755 %buildroot{%_sbindir,%_sysconfdir/{net,%bname,xinetd.d},%_man8dir,%_datadir/%bname/{scripts,plugins/%bname-build-client/{%Codename,common}},%_localstatedir/tftpboot/ltsp,%_sysconfdir/%bname}
install -m 0755 server/{ldminfod,ltsp-{build,update}-*,nbdswapd} %buildroot%_sbindir/
install -m 0644 debian/doc/*.8 %buildroot%_man8dir/
install -m 0755 server/scripts/* %buildroot%_datadir/%bname/scripts/
install -m 0755 %SOURCE7 %buildroot%_datadir/%bname/scripts/gen-%bname-image
install -m 0644 server/plugins/functions %buildroot%_datadir/%bname/plugins/
install -m 0644 server/plugins/%bname-build-client/common/* %buildroot%_datadir/%bname/plugins/%bname-build-client/common/
install -m 0644 server/plugins/%bname-build-client/%Codename/* %buildroot%_datadir/%bname/plugins/%bname-build-client/%Codename/
sed \
    -e 's|@VENDOR@|%Codename|' \
    -e 's|@ARCH@|%_target_cpu|' \
    %SOURCE1 > %buildroot%_sysconfdir/%bname/%bname-build-client.conf
touch %buildroot%_sysconfdir/%bname/%bname-update-kernels.conf
install -m 0644 %SOURCE11 %buildroot%_sysconfdir/%bname/update-kernels.conf
install -d -m 0755 %buildroot%_sysconfdir/%bname
sed \
    -e 's|/opt|%_localstatedir|' \
    -e 's|/ltsp/i386|/ltsp5/%_target_cpu|' \
    server/dhcpd.conf > %buildroot%_sysconfdir/%bname/dhcpd.conf
#install -m 0644 SOURCE13 %buildroot%_sysconfdir/%bname/nbdswapd.conf
install -m 0755 server/%bname-keys %buildroot%_sysconfdir/net/
#install -m 0640 SOURCE11 %buildroot%_sysconfdir/xinetd.d/%bname
#install -m 0640 SOURCE12 %buildroot%_sysconfdir/xinetd.d/nbdswapd

install -d -m 0755 %buildroot{%_bindir,%_initdir,/usr/lib/%bname/{lists,screen.d},%_datadir/%bname-client,%_man1dir,%_localstatedir/%bname-client-setup,%_sysconfdir/{profile.d,bashrc.d,rc.d/scripts}}
install -m 0755 client/{build_x*_cfg,screen_session,start_*,telnet_loop,update-kernels} %buildroot/usr/lib/%bname/
install -m 0755 client/screen.d/* %buildroot/usr/lib/%bname/screen.d/
install -m 0644 client/%{bname}_* %buildroot/usr/lib/%bname/
install -m 0644 %SOURCE9 %buildroot/usr/lib/%bname/lists/%bname-client-eth-modules.list
install -m 0755 %SOURCE10 %buildroot%_sysconfdir/profile.d/%bname-client-mkinitrd.sh
ln -sf ../profile.d/%bname-client-mkinitrd.sh %buildroot%_sysconfdir/bashrc.d/%bname-client-mkinitrd.sh
install -m 0755 client/getltscfg/getltscfg %buildroot%_bindir/
install -m 0644 client/getltscfg/getltscfg.1 %buildroot%_man1dir/
install -m 0755 client/initramfs/init-bottom/unionfs_cow %buildroot%_datadir/%bname-client
install -pD -m 0644 %SOURCE2 %buildroot%_sysconfdir/default/%bname-client-setup
install -m 0755 %SOURCE8 %buildroot%_sysconfdir/rc.d/scripts/%bname-client-bind-mounts
install -m 0755 %SOURCE3 %buildroot%_initdir/%bname-client
install -m 0755 %SOURCE4 %buildroot%_initdir/%bname-client-setup
install -m 0644 %SOURCE5 %buildroot%_sysconfdir/lts.conf
install -pD -m 0755 %SOURCE12 %buildroot%_sysconfdir/X11/xinit.d/%bname-client-sound

install -d -m 0755 %buildroot{/usr/lib/%bname/greeters,%_datadir/ldm/themes/{Debian{,-Edu},{Edu,U}buntu}}
install -m 0644 client/greeters/{greeter.*,gtkrc} %buildroot/usr/lib/%bname/greeters/
install -m 0755 client/greeters/gtk %buildroot/usr/lib/%bname/greeters/gtk.py
install -m 0755 client/ldm %buildroot%_sbindir/ldm.py
ln -sf ldm.py %buildroot%_sbindir/ldm
install -m 0644 client/ldm.1 %buildroot%_man1dir/
install -m 0755 client/ldm-askpass %buildroot/usr/lib/%bname/
for d in Debian Debian-Edu Edubuntu Ubuntu; do
	install -m 0644 client/themes/$d/* %buildroot%_datadir/ldm/themes/$d/
done
ln -sf Ubuntu %buildroot%_datadir/ldm/themes/default

%find_lang %bname


%post server
/usr/sbin/useradd %ltspadmin_user 2> /dev/null || :
/usr/sbin/hasher-useradd %ltspadmin_user 2> /dev/null || :
cat > %_sysconfdir/hasher-priv/user.d/%ltspadmin_user << __CONF__
user1=ltspadmin_a
user2=ltspadmin_b
allow_ttydev=YES
allowed_mountpoints=/dev/pts
__CONF__
chown root:%ltspadmin_user %_sysconfdir/hasher-priv/user.d/%ltspadmin_user
chmod 0640 %_sysconfdir/hasher-priv/user.d/%ltspadmin_user


%post client
%post_service %bname-client-setup
%post_service %bname-client

%preun client
%preun_service %bname-client
%preun_service %bname-client-setup


%files server -f %bname.lang
%doc TODO debian/NEWS debian/README.Debian debian/changelog.*
%doc server/doc/examples server/doc/plugins
%doc debian/doc/swap debian/doc/workstation
%_sbindir/ltsp-*
%_sbindir/ldminfod
#_sbindir/nbdswapd
%_man8dir/*
%dir %_datadir/%bname
%_datadir/%bname/plugins/functions
%dir %_datadir/%bname/scripts
%_datadir/%bname/scripts/*
%dir %_datadir/%bname/plugins/%bname-build-client
%dir %_datadir/%bname/plugins/%bname-build-client/common
%_datadir/%bname/plugins/%bname-build-client/common/*
%dir %_datadir/%bname/plugins/%bname-build-client/%Codename
%_datadir/%bname/plugins/%bname-build-client/%Codename/*
%config(noreplace) %_sysconfdir/%bname/%bname-build-client.conf
%config(noreplace) %_sysconfdir/%bname/%bname-update-kernels.conf
%config(noreplace) %_sysconfdir/%bname/update-kernels.conf
#config(noreplace) %_sysconfdir/%bname/nbdswapd.conf
%config(noreplace) %_sysconfdir/%bname/dhcpd.conf
#config(noreplace) %_sysconfdir/xinetd.d/%bname
#config(noreplace) %_sysconfdir/xinetd.d/nbdswapd
%_sysconfdir/net/%bname-keys
%dir %_localstatedir/tftpboot/ltsp


%files client
%doc client/getltscfg/lts.conf client/lts-parameters.txt
%_bindir/*
%_man1dir/getltscfg.1*
%dir %_localstatedir/%bname-client-setup
%dir /usr/lib/%bname
/usr/lib/%bname/build_x*_cfg
/usr/lib/%bname/screen_session
/usr/lib/%bname/start_*
/usr/lib/%bname/telnet_loop
/usr/lib/%bname/ltsp_*
/usr/lib/%bname/update-kernels
%dir /usr/lib/%bname/lists
/usr/lib/%bname/lists/*
%dir /usr/lib/%bname/screen.d
/usr/lib/%bname/screen.d/*
%dir %_datadir/%bname-client
%_datadir/%bname-client/*
%config(noreplace) %_sysconfdir/default/*
%config(noreplace) %_sysconfdir/lts.conf
%_initdir/%bname-client*
%_sysconfdir/rc.d/scripts/*
%_sysconfdir/profile.d/*
%_sysconfdir/bashrc.d/*
%_sysconfdir/X11/xinit.d/*


%files -n ldm
%_sbindir/ldm*
%_man1dir/ldm.1*
/usr/lib/%bname/ldm-askpass
/usr/lib/%bname/greeters
%dir %_datadir/ldm
%dir %_datadir/ldm/themes
%_datadir/ldm/themes/*


%changelog
* Mon May 21 2007 Led <led@altlinux.ru> 5.0-alt0.12
- updated lts.conf.default
- added %_sysconfdir/X11/xinit.d/%bname-client-sound
- updated %bname-client.init: audio
- updated 005-nbdswapd: default swap dir is /var/spool/swaps

* Fri May 18 2007 Led <led@altlinux.ru> 5.0-alt0.11
- fixed %%files for %name-client: noreplace configs
- fixed %bname-client.init: audio

* Fri May 18 2007 Led <led@altlinux.ru> 5.0-alt0.10
- updated %bname-client-setup.init: support POWER_BUTTON conf parameter
- updated %bname-client.init: load ALSA's OSS-compat module if needed

* Thu May 17 2007 Led <led@altlinux.ru> 5.0-alt0.9
- updated %name-alt.patch:
  + cleaned up
  + loop in screen_session
- fixed %bname-client-setup.init and %bname-client-setup.default for
  customizing keyboard

* Wed May 16 2007 Led <led@altlinux.ru> 5.0-alt0.8
- updated %bname-client-mkinitrd.sh: support --noload minitrd's key

* Wed May 16 2007 Led <led@altlinux.ru> 5.0-alt0.7
- changed default %bname-build-client.conf
- fixed 000-init-whitelist
- updated %name-alt.patch:
  + remove runlevel in kernel parameters
- fixed 000-basic-configuration
- fixed %_sysconfdir/%bname/dhcpd.conf

* Fri May 11 2007 Led <led@altlinux.ru> 5.0-alt0.6
- fixed esd support in %bname-client.init
- updated %name-alt.patch:
  + default runlevel 2
- fixed Sisyphus/000-init-whitelist

* Thu May 10 2007 Led <led@altlinux.ru> 5.0-alt0.5
- fixed Sisyphus/095-exports
- fixed Requires for %name-server
- cleaned up %name-server %%files
- default UDP protocol for NFSROOT
- updated %name-alt.patch
- updated %_sysconfdir/%bname/update-kernels.conf

* Mon May 07 2007 Led <led@altlinux.ru> 5.0-alt0.4
- cleaned up %bname-client-setup.init

* Thu Apr 26 2007 Led <led@altlinux.ru> 5.0-alt0.3
- updated %name-alt.patch
- updated %bname-client-setup.init
- updated %bname-client.init
- set %name-client Conflicts

* Mon Apr 23 2007 Led <led@altlinux.ru> 5.0-alt0.2
- fixed %bname-client-setup.init and lts.conf.default for support local
  client devices

* Mon Apr 16 2007 Led <led@altlinux.ru> 5.0-alt0.1
- initial build
